/* plugin-contact-store.c generated by valac 0.48.17, the Vala compiler
 * generated from plugin-contact-store.vala, do not modify */

/*
 * Copyright © 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include "geary-engine.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>

#define PLUGIN_TYPE_CONTACT_STORE (plugin_contact_store_get_type ())
#define PLUGIN_CONTACT_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_CONTACT_STORE, PluginContactStore))
#define PLUGIN_IS_CONTACT_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_CONTACT_STORE))
#define PLUGIN_CONTACT_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_CONTACT_STORE, PluginContactStoreIface))

typedef struct _PluginContactStore PluginContactStore;
typedef struct _PluginContactStoreIface PluginContactStoreIface;

#define APPLICATION_TYPE_CONTACT (application_contact_get_type ())
#define APPLICATION_CONTACT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_CONTACT, ApplicationContact))
#define APPLICATION_CONTACT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_TYPE_CONTACT, ApplicationContactClass))
#define APPLICATION_IS_CONTACT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_CONTACT))
#define APPLICATION_IS_CONTACT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_TYPE_CONTACT))
#define APPLICATION_CONTACT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_TYPE_CONTACT, ApplicationContactClass))

typedef struct _ApplicationContact ApplicationContact;
typedef struct _ApplicationContactClass ApplicationContactClass;

struct _PluginContactStoreIface {
	GTypeInterface parent_iface;
	void (*search) (PluginContactStore* self, const gchar* query, guint min_importance, guint limit, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeCollection* (*search_finish) (PluginContactStore* self, GAsyncResult* _res_, GError** error);
	void (*load) (PluginContactStore* self, GearyRFC822MailboxAddress* mailbox, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	ApplicationContact* (*load_finish) (PluginContactStore* self, GAsyncResult* _res_, GError** error);
};

GType application_contact_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ApplicationContact, g_object_unref)
GType plugin_contact_store_get_type (void) G_GNUC_CONST;
void plugin_contact_store_search (PluginContactStore* self,
                                  const gchar* query,
                                  guint min_importance,
                                  guint limit,
                                  GCancellable* cancellable,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_);
GeeCollection* plugin_contact_store_search_finish (PluginContactStore* self,
                                                   GAsyncResult* _res_,
                                                   GError** error);
void plugin_contact_store_load (PluginContactStore* self,
                                GearyRFC822MailboxAddress* mailbox,
                                GCancellable* cancellable,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
ApplicationContact* plugin_contact_store_load_finish (PluginContactStore* self,
                                                      GAsyncResult* _res_,
                                                      GError** error);
static GType plugin_contact_store_get_type_once (void);

void
plugin_contact_store_search (PluginContactStore* self,
                             const gchar* query,
                             guint min_importance,
                             guint limit,
                             GCancellable* cancellable,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	PLUGIN_CONTACT_STORE_GET_INTERFACE (self)->search (self, query, min_importance, limit, cancellable, _callback_, _user_data_);
}

GeeCollection*
plugin_contact_store_search_finish (PluginContactStore* self,
                                    GAsyncResult* _res_,
                                    GError** error)
{
	return PLUGIN_CONTACT_STORE_GET_INTERFACE (self)->search_finish (self, _res_, error);
}

void
plugin_contact_store_load (PluginContactStore* self,
                           GearyRFC822MailboxAddress* mailbox,
                           GCancellable* cancellable,
                           GAsyncReadyCallback _callback_,
                           gpointer _user_data_)
{
	PLUGIN_CONTACT_STORE_GET_INTERFACE (self)->load (self, mailbox, cancellable, _callback_, _user_data_);
}

ApplicationContact*
plugin_contact_store_load_finish (PluginContactStore* self,
                                  GAsyncResult* _res_,
                                  GError** error)
{
	return PLUGIN_CONTACT_STORE_GET_INTERFACE (self)->load_finish (self, _res_, error);
}

static void
plugin_contact_store_default_init (PluginContactStoreIface * iface,
                                   gpointer iface_data)
{
}

/**
 * Provides plugins with access to contact information.
 *
 * Plugins may obtain instances of this object from their context
 * objects, for example {@link
 * NotificationContext.get_contacts_for_folder}.
 */
static GType
plugin_contact_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PluginContactStoreIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plugin_contact_store_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType plugin_contact_store_type_id;
	plugin_contact_store_type_id = g_type_register_static (G_TYPE_INTERFACE, "PluginContactStore", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (plugin_contact_store_type_id, GEARY_TYPE_BASE_OBJECT);
	return plugin_contact_store_type_id;
}

GType
plugin_contact_store_get_type (void)
{
	static volatile gsize plugin_contact_store_type_id__volatile = 0;
	if (g_once_init_enter (&plugin_contact_store_type_id__volatile)) {
		GType plugin_contact_store_type_id;
		plugin_contact_store_type_id = plugin_contact_store_get_type_once ();
		g_once_init_leave (&plugin_contact_store_type_id__volatile, plugin_contact_store_type_id);
	}
	return plugin_contact_store_type_id__volatile;
}

