/* plugin-folder-store.c generated by valac 0.48.17, the Vala compiler
 * generated from plugin-folder-store.vala, do not modify */

/*
 * Copyright © 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include "geary-engine.h"
#include <glib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define PLUGIN_TYPE_FOLDER_STORE (plugin_folder_store_get_type ())
#define PLUGIN_FOLDER_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_FOLDER_STORE, PluginFolderStore))
#define PLUGIN_IS_FOLDER_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_FOLDER_STORE))
#define PLUGIN_FOLDER_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_FOLDER_STORE, PluginFolderStoreIface))

typedef struct _PluginFolderStore PluginFolderStore;
typedef struct _PluginFolderStoreIface PluginFolderStoreIface;

#define PLUGIN_TYPE_FOLDER (plugin_folder_get_type ())
#define PLUGIN_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_FOLDER, PluginFolder))
#define PLUGIN_IS_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_FOLDER))
#define PLUGIN_FOLDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_FOLDER, PluginFolderIface))

typedef struct _PluginFolder PluginFolder;
typedef struct _PluginFolderIface PluginFolderIface;

#define PLUGIN_TYPE_ACCOUNT (plugin_account_get_type ())
#define PLUGIN_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_ACCOUNT, PluginAccount))
#define PLUGIN_IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_ACCOUNT))
#define PLUGIN_ACCOUNT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_ACCOUNT, PluginAccountIface))

typedef struct _PluginAccount PluginAccount;
typedef struct _PluginAccountIface PluginAccountIface;

#define PLUGIN_TYPE_EMAIL_IDENTIFIER (plugin_email_identifier_get_type ())
#define PLUGIN_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_EMAIL_IDENTIFIER, PluginEmailIdentifier))
#define PLUGIN_IS_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_EMAIL_IDENTIFIER))
#define PLUGIN_EMAIL_IDENTIFIER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_EMAIL_IDENTIFIER, PluginEmailIdentifierIface))

typedef struct _PluginEmailIdentifier PluginEmailIdentifier;
typedef struct _PluginEmailIdentifierIface PluginEmailIdentifierIface;
enum  {
	PLUGIN_FOLDER_STORE_FOLDERS_AVAILABLE_SIGNAL,
	PLUGIN_FOLDER_STORE_FOLDERS_UNAVAILABLE_SIGNAL,
	PLUGIN_FOLDER_STORE_FOLDERS_TYPE_CHANGED_SIGNAL,
	PLUGIN_FOLDER_STORE_FOLDER_SELECTED_SIGNAL,
	PLUGIN_FOLDER_STORE_NUM_SIGNALS
};
static guint plugin_folder_store_signals[PLUGIN_FOLDER_STORE_NUM_SIGNALS] = {0};

struct _PluginAccountIface {
	GTypeInterface parent_iface;
	const gchar* (*get_display_name) (PluginAccount* self);
};

struct _PluginFolderIface {
	GTypeInterface parent_iface;
	const gchar* (*get_persistent_id) (PluginFolder* self);
	const gchar* (*get_display_name) (PluginFolder* self);
	GearyFolderSpecialUse (*get_used_as) (PluginFolder* self);
	PluginAccount* (*get_account) (PluginFolder* self);
	GVariant* (*to_variant) (PluginFolder* self);
};

struct _PluginEmailIdentifierIface {
	GTypeInterface parent_iface;
	PluginAccount* (*get_account) (PluginEmailIdentifier* self);
	GVariant* (*to_variant) (PluginEmailIdentifier* self);
};

struct _PluginFolderStoreIface {
	GTypeInterface parent_iface;
	const GVariantType* (*get_folder_variant_type) (PluginFolderStore* self);
	GeeCollection* (*get_folders) (PluginFolderStore* self);
	void (*list_containing_folders) (PluginFolderStore* self, PluginEmailIdentifier* target, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeCollection* (*list_containing_folders_finish) (PluginFolderStore* self, GAsyncResult* _res_, GError** error);
	void (*create_personal_folder) (PluginFolderStore* self, PluginAccount* target, const gchar* name, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	PluginFolder* (*create_personal_folder_finish) (PluginFolderStore* self, GAsyncResult* _res_, GError** error);
	PluginFolder* (*get_folder_for_variant) (PluginFolderStore* self, GVariant* id);
};

GType plugin_account_get_type (void) G_GNUC_CONST;
GType plugin_folder_get_type (void) G_GNUC_CONST;
GType plugin_email_identifier_get_type (void) G_GNUC_CONST;
GType plugin_folder_store_get_type (void) G_GNUC_CONST;
const GVariantType* plugin_folder_store_get_folder_variant_type (PluginFolderStore* self);
GeeCollection* plugin_folder_store_get_folders (PluginFolderStore* self);
void plugin_folder_store_list_containing_folders (PluginFolderStore* self,
                                                  PluginEmailIdentifier* target,
                                                  GCancellable* cancellable,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
GeeCollection* plugin_folder_store_list_containing_folders_finish (PluginFolderStore* self,
                                                                   GAsyncResult* _res_,
                                                                   GError** error);
void plugin_folder_store_create_personal_folder (PluginFolderStore* self,
                                                 PluginAccount* target,
                                                 const gchar* name,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
PluginFolder* plugin_folder_store_create_personal_folder_finish (PluginFolderStore* self,
                                                                 GAsyncResult* _res_,
                                                                 GError** error);
PluginFolder* plugin_folder_store_get_folder_for_variant (PluginFolderStore* self,
                                                          GVariant* id);
static GType plugin_folder_store_get_type_once (void);

const GVariantType*
plugin_folder_store_get_folder_variant_type (PluginFolderStore* self)
{
	g_return_val_if_fail (PLUGIN_IS_FOLDER_STORE (self), NULL);
	return PLUGIN_FOLDER_STORE_GET_INTERFACE (self)->get_folder_variant_type (self);
}

/** Returns a read-only set of all known folders. */
GeeCollection*
plugin_folder_store_get_folders (PluginFolderStore* self)
{
	g_return_val_if_fail (PLUGIN_IS_FOLDER_STORE (self), NULL);
	return PLUGIN_FOLDER_STORE_GET_INTERFACE (self)->get_folders (self);
}

void
plugin_folder_store_list_containing_folders (PluginFolderStore* self,
                                             PluginEmailIdentifier* target,
                                             GCancellable* cancellable,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	PLUGIN_FOLDER_STORE_GET_INTERFACE (self)->list_containing_folders (self, target, cancellable, _callback_, _user_data_);
}

GeeCollection*
plugin_folder_store_list_containing_folders_finish (PluginFolderStore* self,
                                                    GAsyncResult* _res_,
                                                    GError** error)
{
	return PLUGIN_FOLDER_STORE_GET_INTERFACE (self)->list_containing_folders_finish (self, _res_, error);
}

void
plugin_folder_store_create_personal_folder (PluginFolderStore* self,
                                            PluginAccount* target,
                                            const gchar* name,
                                            GCancellable* cancellable,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	PLUGIN_FOLDER_STORE_GET_INTERFACE (self)->create_personal_folder (self, target, name, cancellable, _callback_, _user_data_);
}

PluginFolder*
plugin_folder_store_create_personal_folder_finish (PluginFolderStore* self,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	return PLUGIN_FOLDER_STORE_GET_INTERFACE (self)->create_personal_folder_finish (self, _res_, error);
}

/**
     * Returns the folder specified by the given variant, if any.
     *
     * @see Folder.to_variant
     * @see folder_variant_type
     */
PluginFolder*
plugin_folder_store_get_folder_for_variant (PluginFolderStore* self,
                                            GVariant* id)
{
	g_return_val_if_fail (PLUGIN_IS_FOLDER_STORE (self), NULL);
	return PLUGIN_FOLDER_STORE_GET_INTERFACE (self)->get_folder_for_variant (self, id);
}

static void
plugin_folder_store_default_init (PluginFolderStoreIface * iface,
                                  gpointer iface_data)
{
	/**
	     * The type of variant folder identifiers.
	     *
	     * @see Folder.to_variant
	     * @see get_folder_for_variant
	     */
	g_object_interface_install_property (iface, g_param_spec_boxed ("folder-variant-type", "folder-variant-type", "folder-variant-type", G_TYPE_VARIANT_TYPE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** Emitted when new folders are available. */
	plugin_folder_store_signals[PLUGIN_FOLDER_STORE_FOLDERS_AVAILABLE_SIGNAL] = g_signal_new ("folders-available", PLUGIN_TYPE_FOLDER_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	/** Emitted when existing folders have become unavailable. */
	plugin_folder_store_signals[PLUGIN_FOLDER_STORE_FOLDERS_UNAVAILABLE_SIGNAL] = g_signal_new ("folders-unavailable", PLUGIN_TYPE_FOLDER_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	/** Emitted when existing folders have become unavailable. */
	plugin_folder_store_signals[PLUGIN_FOLDER_STORE_FOLDERS_TYPE_CHANGED_SIGNAL] = g_signal_new ("folders-type-changed", PLUGIN_TYPE_FOLDER_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
	/** Emitted when a folder has been selected in any main window. */
	plugin_folder_store_signals[PLUGIN_FOLDER_STORE_FOLDER_SELECTED_SIGNAL] = g_signal_new ("folder-selected", PLUGIN_TYPE_FOLDER_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, PLUGIN_TYPE_FOLDER);
}

/**
 * Provides plugins with access to folders.
 *
 * Plugins that implement the {@link FolderExtension} interface may
 * obtain instances of this object by calling {@link
 * FolderContext.get_folder_store} on their {@link
 * FolderExtension.folders} property.
 */
static GType
plugin_folder_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PluginFolderStoreIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plugin_folder_store_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType plugin_folder_store_type_id;
	plugin_folder_store_type_id = g_type_register_static (G_TYPE_INTERFACE, "PluginFolderStore", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (plugin_folder_store_type_id, GEARY_TYPE_BASE_OBJECT);
	return plugin_folder_store_type_id;
}

GType
plugin_folder_store_get_type (void)
{
	static volatile gsize plugin_folder_store_type_id__volatile = 0;
	if (g_once_init_enter (&plugin_folder_store_type_id__volatile)) {
		GType plugin_folder_store_type_id;
		plugin_folder_store_type_id = plugin_folder_store_get_type_once ();
		g_once_init_leave (&plugin_folder_store_type_id__volatile, plugin_folder_store_type_id);
	}
	return plugin_folder_store_type_id__volatile;
}

