/* plugin-folder.c generated by valac 0.48.17, the Vala compiler
 * generated from plugin-folder.vala, do not modify */

/*
 * Copyright © 2020 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define PLUGIN_TYPE_FOLDER (plugin_folder_get_type ())
#define PLUGIN_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_FOLDER, PluginFolder))
#define PLUGIN_IS_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_FOLDER))
#define PLUGIN_FOLDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_FOLDER, PluginFolderIface))

typedef struct _PluginFolder PluginFolder;
typedef struct _PluginFolderIface PluginFolderIface;

#define PLUGIN_TYPE_ACCOUNT (plugin_account_get_type ())
#define PLUGIN_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_ACCOUNT, PluginAccount))
#define PLUGIN_IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_ACCOUNT))
#define PLUGIN_ACCOUNT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), PLUGIN_TYPE_ACCOUNT, PluginAccountIface))

typedef struct _PluginAccount PluginAccount;
typedef struct _PluginAccountIface PluginAccountIface;

struct _PluginAccountIface {
	GTypeInterface parent_iface;
	const gchar* (*get_display_name) (PluginAccount* self);
};

struct _PluginFolderIface {
	GTypeInterface parent_iface;
	const gchar* (*get_persistent_id) (PluginFolder* self);
	const gchar* (*get_display_name) (PluginFolder* self);
	GearyFolderSpecialUse (*get_used_as) (PluginFolder* self);
	PluginAccount* (*get_account) (PluginFolder* self);
	GVariant* (*to_variant) (PluginFolder* self);
};

GType plugin_account_get_type (void) G_GNUC_CONST;
GType plugin_folder_get_type (void) G_GNUC_CONST;
const gchar* plugin_folder_get_persistent_id (PluginFolder* self);
const gchar* plugin_folder_get_display_name (PluginFolder* self);
GearyFolderSpecialUse plugin_folder_get_used_as (PluginFolder* self);
PluginAccount* plugin_folder_get_account (PluginFolder* self);
GVariant* plugin_folder_to_variant (PluginFolder* self);
static GType plugin_folder_get_type_once (void);

const gchar*
plugin_folder_get_persistent_id (PluginFolder* self)
{
	g_return_val_if_fail (PLUGIN_IS_FOLDER (self), NULL);
	return PLUGIN_FOLDER_GET_INTERFACE (self)->get_persistent_id (self);
}

const gchar*
plugin_folder_get_display_name (PluginFolder* self)
{
	g_return_val_if_fail (PLUGIN_IS_FOLDER (self), NULL);
	return PLUGIN_FOLDER_GET_INTERFACE (self)->get_display_name (self);
}

GearyFolderSpecialUse
plugin_folder_get_used_as (PluginFolder* self)
{
	g_return_val_if_fail (PLUGIN_IS_FOLDER (self), 0);
	return PLUGIN_FOLDER_GET_INTERFACE (self)->get_used_as (self);
}

PluginAccount*
plugin_folder_get_account (PluginFolder* self)
{
	g_return_val_if_fail (PLUGIN_IS_FOLDER (self), NULL);
	return PLUGIN_FOLDER_GET_INTERFACE (self)->get_account (self);
}

/**
     * Returns a variant identifying this account and folder.
     *
     * This value can be used to obtain folders from {@link
     * FolderStore}, and is suitable to be used as the `show-folder`
     * application action parameter.
     *
     * @see FolderStore.get_folder_for_variant
     * @see FolderStore.folder_variant_type
     */
GVariant*
plugin_folder_to_variant (PluginFolder* self)
{
	g_return_val_if_fail (PLUGIN_IS_FOLDER (self), NULL);
	return PLUGIN_FOLDER_GET_INTERFACE (self)->to_variant (self);
}

static void
plugin_folder_default_init (PluginFolderIface * iface,
                            gpointer iface_data)
{
	/**
	     * Returns a unique identifier for this account and folder.
	     *
	     * The value returned is persistent across application restarts.
	     */
	g_object_interface_install_property (iface, g_param_spec_string ("persistent-id", "persistent-id", "persistent-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** Returns the human-readable name of this folder. */
	g_object_interface_install_property (iface, g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** Returns the type of this folder. */
	g_object_interface_install_property (iface, g_param_spec_enum ("used-as", "used-as", "used-as", GEARY_FOLDER_TYPE_SPECIAL_USE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/** Returns the account the folder belongs to, if any. */
	g_object_interface_install_property (iface, g_param_spec_object ("account", "account", "account", PLUGIN_TYPE_ACCOUNT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

/**
 * An object representing a folder for use by plugins.
 *
 * Instances of these may be obtained from {@link FolderStore}.
 */
static GType
plugin_folder_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PluginFolderIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plugin_folder_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType plugin_folder_type_id;
	plugin_folder_type_id = g_type_register_static (G_TYPE_INTERFACE, "PluginFolder", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (plugin_folder_type_id, GEARY_TYPE_BASE_OBJECT);
	return plugin_folder_type_id;
}

GType
plugin_folder_get_type (void)
{
	static volatile gsize plugin_folder_type_id__volatile = 0;
	if (g_once_init_enter (&plugin_folder_type_id__volatile)) {
		GType plugin_folder_type_id;
		plugin_folder_type_id = plugin_folder_get_type_once ();
		g_once_init_leave (&plugin_folder_type_id__volatile, plugin_folder_type_id);
	}
	return plugin_folder_type_id__volatile;
}

